/*******************************************************************************
 
  $Id: dll_stub.cpp,v 1.1 1997/10/05 06:39:20 eug Exp eug $

  (C)Copyright 1997 by Eugene Surovegin <ebs@glasnet.ru>

  DLL entry points

*******************************************************************************/
#include "stdafx.h"
#include "ntsecapi.h"
#include "DictionaryFile.h"
#include "RegSupport.h"

static char _about[]="Dictionary Password Filter, version 1.0 ("__DATE__")\n"
                     "Copyright  1997 by Eugene Surovegin <ebs@glasnet.ru>\n\n"
                     "Usage:\n"
                     "   rundll32  dictfilt.dll,about - get this screen\n"
                     "   rundll32  dictfilt.dll,install - install filter\n"
                     "   rundll32  dictfilt.dll,uninstall - remove filter\n";

void WINAPI about(HWND hwnd, HINSTANCE hinst, LPSTR lpszCmdLine, int nCmdShow){
  ::MessageBox(hwnd,_about,"About",MB_OK|MB_ICONINFORMATION);
}

void WINAPI install(HWND hwnd, HINSTANCE hinst, LPSTR lpszCmdLine, int nCmdShow){
  if (InstallFilter(hwnd) && InstallLog(hwnd))
    MessageBox(hwnd,"Filter installed succefully.\nPlease reboot...","Install",MB_OK|MB_ICONINFORMATION);  
  else
    MessageBox(hwnd,"Filter installation failed.","Install",MB_OK|MB_ICONSTOP);  
}

void WINAPI uninstall(HWND hwnd, HINSTANCE hinst, LPSTR lpszCmdLine, int nCmdShow){
  if (RemoveFilter(hwnd) && RemoveLog(hwnd))
    MessageBox(hwnd,"Filter uninstalled succefully.\nPlease reboot and then delete DictFilt.Dll from system32 directory.","UnInstall",MB_OK|MB_ICONINFORMATION);  
  else
    MessageBox(hwnd,"Filter uninstallation failed.","UnInstall",MB_OK|MB_ICONSTOP);  
}

BOOL NTAPI PasswordFilter(PUNICODE_STRING AccountName,PUNICODE_STRING FullName, PUNICODE_STRING Password,
               IN BOOLEAN SetOperation){
  
  char _password[256];
  BOOLEAN res=TRUE;
  CDictionaryFile df;

  __try {

    ZeroMemory(_password,sizeof(_password));
    WideCharToMultiByte(CP_ACP,0,Password->Buffer,Password->Length/sizeof(WCHAR),
      _password,sizeof(_password),NULL,NULL);

    if (df.MapFile()){
      if (df.LookUpPassword(_password)) res=FALSE;
      df.UnMapFile();
    }
  }
  __except(1){
    // catch all exceptions here
    df.UnMapFile();
  }

  ZeroMemory(_password,sizeof(_password));  
  return res;
}

