/*******************************************************************************
 
  $Id: DictionaryFile.cpp,v 1.1 1997/10/05 06:38:50 eug Exp eug $

  (C)Copyright 1997 by Eugene Surovegin <ebs@glasnet.ru>

  Implementation of CDictionaryFile class - working with dict file

*******************************************************************************/
#include "stdafx.h"
#include <string.h>
#include "DictionaryFile.h"

// Hard-coded file name 
#define DICTIONARY_FILE "\\allwords"
//#define DICTIONARY_FILE "\\all"

bool CDictionaryFile::MapFile(){
  _ASSERT(hFile==INVALID_HANDLE_VALUE);
  _ASSERT(hMap==NULL);

  char file_path[MAX_PATH];
  bool res=false;
  CErrorLog::errorType error;

  GetSystemDirectory(file_path,MAX_PATH);
  strcat(file_path,DICTIONARY_FILE);
  
  if ( (hFile=CreateFile(file_path,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,
      FILE_ATTRIBUTE_NORMAL,NULL))!=INVALID_HANDLE_VALUE)
    if (dwSize=GetFileSize(hFile,NULL))
      if ((hMap=CreateFileMapping(hFile,NULL,PAGE_READONLY,0,0,NULL))!=NULL)
        if ( (ptr=(char*)MapViewOfFile(hMap,FILE_MAP_READ,0,0,0))!=NULL)
          res=true;
        else error=CErrorLog::etCannotMap;
      else error=CErrorLog::etNoMapObject;
    else error=CErrorLog::etEmptyFile;
  else error=CErrorLog::etNoFile;

  if (!res){
    log.ReportError(error);
    if (hMap!=NULL) CloseHandle(hMap);
    if (hFile!=INVALID_HANDLE_VALUE) CloseHandle(hFile);
#ifdef DEBUG
    hFile=INVALID_HANDLE_VALUE;
    hMap=NULL;
    ptr=NULL;
    dwSize=0;
#endif
  }
  return res;
}

void CDictionaryFile::UnMapFile(void){

  if (ptr!=NULL) UnmapViewOfFile(ptr); 
  if (hMap!=NULL) CloseHandle(hMap);
  if (hFile!=INVALID_HANDLE_VALUE) CloseHandle(hFile);

#ifdef DEBUG
  ptr=NULL;
  hMap=NULL;
  hFile=INVALID_HANDLE_VALUE;
#endif
}

bool CDictionaryFile::LookUpPassword(const char * pass){
  _ASSERT(ptr!=NULL);

  bool res=false;
  DWORD i=0,j=0;
  DWORD pass_len=strlen(pass);

  while (i<dwSize){
    while( (ptr[j]!=0xd) && (ptr[j]!=0xa) && (j<(dwSize-1)) ) j++;
    if ((j-i)==pass_len){
      if (!strncmp(pass,(ptr+i),pass_len)){
        res=true;
        break;
      }
    }
    i=++j;
  }
  return res;
}
